;-------------= Avalanche =-------------
; Author:       Ian Graf (port)
;               (ian_graf@geocities.com)
;               Harper Maddox (original)
;               (jerky@ebicom.net)
; Version:      1.2
; Platform:     ION
; Date:         11/3/99
;---------------------------------------
;-------------= Avalanche =-------------
;Author:    Peter Jedraszczak (Port)
;           pbjiam@hotmail.com
;           Mirage OS Port
;           August 1 2000
;---------------------------------------
;-------------= Avalanche =-------------
;Author:     Rayden (Port)
;           shadel540@hotmail.com
;           MacroDie OS Port
;           August 19 2006







;---------------= header =--------------
#include    "ti83plus.inc"              ;General TI-83 Plus include file
#include    "macrodie.inc"              ;Macrodie OS include file
        .org    $9d95                   ;Origin (set back two to account for AsmPrgm)
        ;.db $BB,$6D                    ;Compiled AsmPrgm token
        ret                             ;So TIOS wont run the program
        jr  start_of_program1           ;Identifier as Macrodie OS program
        LD  BC,ram_area_end - ram_area_init  ;the program ram area size 
icon:
        .db %10100010, %00001100
        .db %10001000, %01010001
        .db %00100010, %10000000
        .db %00010000, %00000000
        .db %00000000, %00100000
        .db %00110000, %00000000
        .db %00110000, %00000000
        .db %11111111, %11111111
        .db %11111111, %11111111
        .db %00000000, %00000000
        .db %00000000, %00000000
        .db %00000000, %00000000
        .db %00000000, %00000000
        .db %00000000, %00000000
        .db %00000000, %00000000
        .db %00000000, %00000000
        
        
start_of_program1:  
        LD      A,(background_state)    ;
        CP      1                     ;
        jp      z,return_from_pause    ;
        LD      A,1                 ;
        LD      (background_state),A    ;
        LD      HL,background_stuff     ;
        xor     a                       ;
        invoke( ADD_program_to_background ) ; ADD program to multitask manager required by all macrodie programs     
start_of_program:      
        bcall   _ClrLCDFull             ;
        ld      de,0*256+16              ;y*256+x
        ld      (_penCol),de            ;IF we write to _textShadow when exiting macrodie will give an overflow error and exit
        set     fracDrawLFont, (IY + fontFlags)
        ld      hl,titlestr             ;
        bcall   _VPutS
        res     fracDrawLFont, (IY + fontFlags)                   ;
        ld      bc,0*256+55             ; draw line
        ld      de,94*256+55            ;
        bcall   _DARKLINE               ;
        ld      de,10*256+1             ; write "By AE, FD, and IG"
        ld      (_penCol),de            ;
        ld      hl,authorstr            ;
        bcall   _VPutS                  ;
        ld      de,22*256+4             ; write "2nd - Start"
        ld      (_penCol),de            ;
        bcall   _VPutS                  ;
        ld      de,29*256+4             ; write "ALPHA - Speed:"
        ld      (_penCol),de            ;
        bcall   _VPutS                  ;
        ld      de,36*256+4             ; write "CLEAR - Exit:"
        ld      (_penCol),de            ;
        bcall   _VPutS                  ;
        ld      de,55*256+1             ; write "High: "
        ld      (_penCol),de            ;
        bcall   _VPutS                  ;
        ld      hl,(high)               ;
        bcall   _SetXXXXOP2             ; write high score
        bcall   _OP2ToOP1               ;
        ld      a,5                     ;
        bcall   _DispOP1A               ;
updatm: ld      de,29*256+53            ; write speed
        ld      (_penCol),de            ;
        ld      a,(speed)               ;
        bcall   _SetXXOP1               ;
        bcall   _DispOP1A               ;
menul:  call    getcsc                   ;
        cp      15                      ; [CLEAR]
        jp      z,quit                  ; quit
        cp      48                      ; [ALPHA]
        jr      nz,nchngs               ;
        ld      hl,speed                ; change num players
        ld      a,(hl)                  ;
        xor     %00000011               ;
        ld      (hl),a                  ;
        jr      updatm                  ;
nchngs: cp      54                      ; [2nd]
        jr      nz,menul                ;
        bcall   _GRBUFCLR               ;
        ld      hl,0                    ; reset score
        ld      (score),hl              ;
        ld      a,44                    ; center man
        ld      (manx),a                ;
        ld      b,12                    ; randomize icicles
        ld      hl,icicles              ;
randl:  
        push    bc                      ;
        ld      b,50                    ;
        call    MRandom                 ;
        ld      (hl),a                  ;
        inc     hl                      ;
        pop     bc                      ;
        djnz    randl                   ;
keyl:   bcall   _GRBUFCLR               ;
        ld      hl,(score)              ; inc score
        inc     hl                      ;
        inc     hl                      ;
        ld      (score),hl              ;
        xor     a                       ;
        ld      hl,icicles              ;
        ld      de,grav                 ;
        ld      b,12                    ;
drawl:  push    bc                      ;
        push    af                      ;
        push    de                      ;
        push    hl                      ;
        ld      d,a                     ; d = x coord
        ld      b,8                     ; b = sprite height
        ld      ix,icicle               ; ix = sprite
        ld      a,(hl)                  ;
        ld      e,a                     ; e = y coord
        cp      25                      ;
        jr      nc,drop                 ;
        ld      b,2                     ; drop 1
        ld      ix,drop1                ;
        ld      e,50                    ;
        jr      draw                    ;
drop:   cp      51                      ;
        jp      nc,chkhit               ;
        ld      b,4                     ; drop 2
        ld      ix,drop2                ;
        ld      e,50                    ;
        jr      draw                    ;
chkhit: cp      96                      ;
        jr      c,draw                  ;
        ld      hl,manx                 ; hl = manx
        ld      a,d                     ;
        add     a,4                     ; a = iciclex + 4
        cp      (hl)                    ; manx > iciclex + 4
        jr      c,draw                  ;
        ld      a,(hl)                  ;
        add     a,4                     ; a = manx + 4
        cp      d                       ; manx + 4 < iciclex
        jr      c,draw                  ;
        pop     hl                      ;
        pop     de                      ;
        pop     af                      ;
        pop     bc                      ;
        jp      exit                    ;

draw:   ld      a,e                     ;
        sub     50                      ;
        ld      l,a                     ;
        ld      h,d                     ;
        LD      C,1                     ; with is only 1 byte
        xor     a                       ; the routine is on macrodie  flash page
        invoke( putsprite )             ; draw icicle
        
        pop     hl                      ;
        pop     de                      ;
        ld      a,(de)                  ;
        add     a,(hl)                  ;
        cp      106                     ;
        jr      c,noup                  ;
        xor     a                       ;

noup:   ld      (hl),a                  ;
        inc     hl                      ;
        inc     de                      ;
        pop     af                      ;
        add     a,8                     ;
        pop     bc                      ;
        djnz    drawl                   ;
        ld      b,10                    ;
        ld      a,(manx)                ;
        LD      H,A                     ; macrodie putsprite routine uses H as xpos
        ld      l,54                    ;
        ld      ix,man                  ;
        LD      C,1                     ; only 8 pixels by x
        xor     a                       ; the routine is on macrodie page
        invoke( putsprite )             ; draw man
        xor     a                       ; the routine is on macrodie page
        invoke( fastcopy )              ; copy plotsscreen to the display ram area
        
        ei                              ; 
        ld      a,(speed)               ;
        add     a,a                     ;
        add     a,3                     ;
        ld      b,a                     ;
delay:  halt                            ;
        djnz    delay                   ;
        ld      a,$FF                   ;
        out     (1),a                   ;
        ld      a,$FE                   ;
        out     (1),a                   ;
        in      a,(1)                   ;
        ld      b,a                     ;
        ld      hl,manx                 ;
        ld      a,(hl)                  ;
        srl     b                       ;
        srl     b                       ;
        jr      c,nleft                 ; [(left)]
        or      a                       ;
        jr      nz,nmover               ;
        ld      a,90+2                  ;
nmover: dec     a                       ;
        dec     a                       ;
nleft:  srl     b                       ;
        jr      c,nright                ; [(right)]
        cp      90                      ;
        jr      nz,nmovel               ;
        ld      a,0-2                   ;
nmovel: inc     a                       ;
        inc     a                       ;
nright: ld      (hl),a                  ;
        call    getcsc                   ;
        cp      55                      ; [MODE]
        jr      nz,npause               ;
        
       ;ld      a,1                     ; turn off calc
       ;out     (3),a                   ;
       ;ei                              ;
       ;halt                            ;
                                        ; minimize task and show macrodie
        LD      (save_DE),DE            ; save the screen temporarly 
        LD      (save_HL),HL            ;
        LD      (save_BC),BC            ;
        LD      HL,_plotSScreen         ;
        LD      DE,_SaveSScreen         ;
        LD      BC,768                  ;
        LDIR                            ;
        XOR  A                          ;
        LD   (activ_task),A             ;
        LD   (close_task),A             ; ordem ao windows para fechar task activa
        LD   (screen),A                 ;
        LD   (animar_flag),A            ;
        RET                             ; return to macrodie
return_from_pause:                      ; get back from macrodie
        LD      HL,_SaveSScreen         ; restore screen
        LD      DE,_plotSScreen         ;    
        LD      BC,768                  ;
        LDIR                            ;
        LD      BC,(save_BC)            ; restore registers
        LD      DE,(save_DE)            ;
        LD      HL,(save_HL)            ;           
        call    getcsc
npause: cp      15                      ; [CLEAR]
        jp      nz,keyl                 ; [CLEAR]
exit:   bcall   _ClrLCDFull             ;
        LD      DE,0                    ;
        LD      (_penCol),DE            ;
        ld      hl,scorestr             ;
        set     fracDrawLFont, (IY + fontFlags)
        bcall   _VPutS                  ; write "Score: "
        ld      hl,(score)              ;
        bcall   _SetXXXXOP2
        bcall   _OP2ToOP1               ;move OP2 to OP1
        LD      A,5
        bcall   _DispOP1A               ;
        ld      hl,(score)              ;
        ld      de,(high)               ;
        bcall   _CpHLDE                 ;
        jr      c,exitl                 ;
        ld      (high),hl               ;
        LD      HL,9*256+0
        LD      (_penCol),HL
        ld      hl,highstr              ;
        
        bcall   _VPutS                    ; write "New High!"
        res     fracDrawLFont, (IY + fontFlags)
exitl:  
        call    getcsc                  ;
        cp      54                      ;
        jp      z,start_of_program      ;
        jr      exitl                   ;
MRandom:                                ; random routine not ouwned by macrodie
        push    hl                      ;
        push    de                      ;
        ld      hl,(data)               ;
        ld      a,r                     ;
        ld      d,a                     ;
        ld      e,(hl)                  ;
        add     hl,de                   ;
        add     a,l                     ;
        xor     h                       ;
        ld      (data),hl               ;
        ld      hl,0                    ;
        ld      e,a                     ;
        ld      d,h                     ;
                                        ;
randl1:                                 ;
        add     hl,de                   ;
        djnz    randl1                  ;
        ld      a,h                     ;
        pop     de                      ;
        pop     hl                      ;
        ret                             ;
background_stuff:                       ; this program has no multitsk code
        RET
getcsc:
        LD     A,$BF
        OUT    (1),A
        IN     A,(1)
        CP     $DF
        jr     z,second_key
        CP     $BF
        jr     z,mode_key
        LD     A,$DF
        OUT    (1),A
        IN     A,(1)
        CP     $7F
        jr     z,alpha_key
        LD     A,$FD
        OUT    (1),A
        IN     A,(1)
        CP     $BF
        jr     z,clear_key
        xor    a
        ret
second_key:
        ld    a,54
        ret
mode_key:
        ld    a,55
        ret
alpha_key:
        ld    a,48
        ret
clear_key:
        ld    a,15
        ret
quit:
        LD    A,(activ_task)            ; get the activ program that's mine
        LD    (close_task),A            ; set it to shutdown
        XOR   A                         ; set a=0
        LD   (activ_task),A             ; set the activ task to zero    
        LD   (screen),A                 ;
        LD   (animar_flag),A            ;
        RET                             ; go to macrodie and shutdown task


ram_area_init:

titlestr:       .db     "Avalanche",0
authorstr:      .db     "By HM and IG",0
startstr:       .db     "2nd - Start",0
playerstr:      .db     "ALPHA - Speed:",0
exitstr:        .db     "CLEAR - Exit",0
hscorestr:      .db     "High: ",0
scorestr:       .db     "Score:",0
highstr:        .db     "New High!",0

grav:   .db     2,3,2,3,2,3,4,3,2,2,3,2

high:   .dw     0
speed:  .db     1

icicle: .db     %01111100
        .db     %01100100
        .db     %01000100
        .db     %00101000
        .db     %00101000
        .db     %00111000
        .db     %00010000
        .db     %00010000
drop1:  .db     %01111100
        .db     %00111000
drop2:  .db     %11111110
        .db     %11000110
        .db     %01000100
        .db     %00111000
man:    .db     %01110000
        .db     %10001000
        .db     %10001000
        .db     %01110000
        .db     %00100000
        .db     %11111000
        .db     %00100000
        .db     %00100000
        .db     %01010000
        .db     %10001000


manx             .db 0     ;1
score            .dw 0     ;2
icicles          .dw 0     ;12
                 .dw 0
                 .dw 0
                 .dw 0
                 .dw 0
                 .dw 0
                 .dw 0     ; failsafe extra byte
data             .dw 0     ;
save_DE          .dw 0
save_BC          .dw 0
save_HL          .dw 0
background_state .db 0


ram_area_end:
        .end
